#include <stdlib.h>

#include "forms.h"
#include "conv.h"
#include <math.h>

#define Pi 3.141592654

/* callbacks for form form1 */

void beenden(FL_OBJECT *ob, long data)
{
      exit(0);
}

void eingabe(FL_OBJECT *ob, long data)
{
   double numerisch;
   char *string, buffer[30];
   string = fl_get_input(ob) ;
   numerisch = atof(string);
   switch(fl_get_choice(wahl))
   {
      case 1:  numerisch=numerisch*Pi/180;break;
      case 2:  numerisch=numerisch/101325;break;
      case 3:  numerisch=numerisch/100000;break;
      case 4:  numerisch=numerisch/133.32;break;
      case 5:  numerisch=numerisch*4.184;break; /*Kalorien -> Joule*/
      case 6:  numerisch=20 * log10(numerisch);break; /*dB*/
      case 7:  numerisch=10 * log10(numerisch);break; /*dB*/
      case 8:  numerisch=numerisch/2.54;break;
      case 9:  numerisch=numerisch+273.15;break;/*C -> Kelvin*/
      default:  return;
   }
   sprintf(buffer,"%lf",numerisch);
   fl_set_input(ein2,buffer);
}

void eingabe2(FL_OBJECT *ob, long data)
{
   double numerisch;
   char  *string, buffer[30];
   string = fl_get_input(ob) ;
   numerisch = atof(string);
   switch(fl_get_choice(wahl))
   {
      case 1:  numerisch=numerisch*180/Pi;break;
      case 2:  numerisch=numerisch*101325;break;
      case 3:  numerisch=numerisch*100000;break;
      case 4:  numerisch=numerisch*133.32;break;
      case 5:  numerisch=numerisch/4.184;break; /* Joule -> Kalorie*/
      case 6:  numerisch=pow(10,(numerisch/20));break; /*dB*/
      case 7:  numerisch=pow(10,(numerisch/10));break;/*dB*/
      case 8:  numerisch=numerisch*2.54;break;
      case 9:  numerisch=numerisch-273.15;break;/*Kelvin -> C*/
      default:  return;
   }
   sprintf(buffer,"%lf",numerisch);
   fl_set_input(ein,buffer);
}

void auswahl(FL_OBJECT *ob, long data)
{
/* fill-in code for callback */
      fl_trigger_object(ein);
}

void version(FL_OBJECT *ob, long data)
{
   fl_show_message("Einheiten-Umrechner von Stefan Heimers\nsheimers@ezinfo.vmsmail.ethz.ch","Version 0.1 17. Juni      1997", "This is freeware, egoism sucks!");
}

void hilfe(FL_OBJECT *ob, long data)
{
   fl_show_message("Einen numerischen Wert in eines der Eingabefelder tippen\nund mit [ENTER] besttigen.","Vor- oder      nacher mit Auswahl eine Umrechnungsart whlen.", "Ausgabe auf der anderen Seite lesen und geniessen!");
}



